#include <iostream>
#include <string>
#include <sstream>
#include <stdlib.h>
#include <time.h>

// bail
//
// ... by Eli Fulkerson.  See http://www.elifulkerson.com for updates
//

/*
    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

using namespace std;

int main(int argc, char* argv[]) {

	string input = "";
	string output = "";

	// by default just the one header line.
	int seconds_to_die = 2;
	
	//parse some arguments
	for ( int i = 0; i < argc; i++) {

		std::string arg = argv[i];
		

		if (arg == "-s") {
			if (i + 1 < argc) {
				seconds_to_die = atoi(argv[i+1]);
			}
		}


		if (arg == "-v" || arg == "--version") {
			cout << "bail v0.1  4 December 2015" << endl
				 << "by Eli Fulkerson.  See http://www.elifulkerson.com for updates" << endl << flush;
			return 0;
		}


		if (arg == "-h" || arg == "--help" || arg == "--usage" || arg == "-?" || arg == "/?" || arg == "/h") {


			cout << "bail eats stdin and emits stdout, but dies after -s seconds. " << endl;
			cout << endl;
			cout << "ps |bail -s 5 |grep whatever" << endl;
			cout << endl;
			cout << "... will stop eating stdin and die after 5 seconds." << endl;
			cout << endl;
			
			cout << "Syntax: your_command | bail -s X | your_other_commands" << endl
				 << "Options:" << endl
				 << "-s X   : die after X seconds (default 2)" << endl
				 << "-v     : display version information" << endl << flush;
			return 0;
		}
	}

	time_t base,now;

	base = time(0);

	long numlines = 0;
	
	while (true) {
		now = time(0);
		
		if (seconds_to_die != -1 && now - base > seconds_to_die) {
			return 1;
		}
		
		getline(cin, input);


		cout << input << endl << flush;


		if (!cin) {
			return 0;
		}

		numlines++;

	}

	return 0;
}
